*.............................................................................
*
*   Program Name: H_MENU.PRG         Language: Clipper - Summer '87
*   Date Created: 07/03/90           Author: Robert N. Heyman                                      
*   Time Created: 18:35:15           Released into the Public Domain                   
*                                    07/06/90   
*   Comments to :
*                   CIS  - 72261,2566
*                  GEnie - R.HEYMAN
*.............................................................................

*notes :
*-- There is VERY little error checking done... you're on your own with
*-- respect to making sure that the main menu is not too long for the
*-- screen and that you place your menu WITHIN the screen. ( remember
*-- that there is a shadow! ).  You may use up to 9 selections per
*-- submenu.

** IMPORTANT - you *MUST* have the Funcky Library (tm) by dLESKO Assoc.
** to use this menu function.

*-- Link       tlink hmenu funcky,,,clipper funcky extend

cls(112)
set cursor off
declare menu_[7]
*-----------------------------------------------------
*-- menu items may have up to nine (9) submenu choices.
*-- Main menu items before the tilde..submenu items separated by a pipe
*-----------------------------------------------------
menu_[1]= "Customers~Add|Edit|Delete|List"
menu_[2]= "Vendors~Add|Edit|Delete"
menu_[3]= "Salesmen~Add|Edit|Delete"
menu_[4]= "Invoices~Add|Edit|Delete"
menu_[5]= "Payments~Add|Edit|Delete|Post|Print|Archive|Back-date|Age|Match"
menu_[6]= "LOC's~Add|Edit|Delete|Post|Print|Purge|Archive"
menu_[7]= "Quit~Yes|No"

menu_choice= 1
maining= .t.

do while maining
     *------------------------------------------------
     *- see RNH_MENU function below for parameter list
     *------------------------------------------------

     menu_choice= Rnh_menu(menu_choice,2,3,menu_,71,79,78,116,3)

     *-------------------------------------------------------
     *-- function returns a numeric with 1 decimal point
     *-------------------------------------------------------
     do case
          case menu_choice= 7.1
               maining= !maining
          otherwise
               sound(4000,200)
               print(24,00,strcenter("Selected Menu Item Is Number "+alltrim(str(menu_choice,3,1)),80),112)
               inkey(2)
               scroll(24,00,24,79,00,112)
     endcase
enddo maining

cls(07)
set cursor on
return
*------------------------------------------------------------------------
function RNH_MENU
     *-  calls to Hili(), Loli(), Submenu(), Hili_s(), Loli_s()
     *-------------------------------------------------------------------
     *-- PARAMETER LIST :
     *-- you MUST pass all parameters except the last one (frame type)
     *-------------------------------------------------------------------
     *--  _active        N         menu element to activate
     *--  _menu_row      N         menu top bar row
     *--  _menu_col      N         column of first prompt
     *--  _menu_pmts_    A         array of prompts
     *--                           each array element will contain a
     *--                           string that contains a main menu
     *--                           prompt followed by a tilde, then a
     *--                           series of submenu prompts separated
     *--                           by a pipe character
     *--                           i.e.   "Customers~Add|Edit|Delete|List"
     *--  _box_clr       N         color of menu box
     *--  _pmt_clr       N         color of prompts
     *--  _first_clr     N         color of first letter of prompt
     *--  _sel_clr       N         color of selected prompt
     *--  _frmtype       N              Ŀ   
     *--                                   Type 1   
     *--                                
     *--                                ͻ
     *--                                   Type 2   
     *--                                ͼ
     *--                                ͸
     *--                                   Type 3   
     *--                                ;
     *--                                ķ
     *--                                   Type 4   
     *--                                Ľ
     *----------------------------------------------------------------

     parameters _active,_menu_row,_menu_col,_menu_pmts_,_box_clr,_pmt_clr,;
     _first_clr,_sel_clr,_frmtype

     if pcount() < 9
          _frmtype= 1
     endif

     private _num_pmts,x,_len_main,_tilde,_curr_col,_temp_col,_menuing, ;
     _the_key,_scr_temp,_frame

     do case
          case _frmtype= 1
               _frame= "Ŀ "
          case _frmtype= 2
               _frame= "ͻȺ "
          case _frmtype= 3
               _frame= "͸Գ "
          case _frmtype=4
               _frame= "ķӺ "
          otherwise
               _frame= "Ŀ "
     endcase


     *-- caller MIGHT pass back a non-integer. This will SURELY cause
     *-- a problem if we don't chop off the decimals
     *--------------------------------------------------------------
     _active= int(_active)

     private _num_pmts,x,_len_main,_tilde,_curr_col,_temp_col,_menuing, ;
     _the_key,_scr_temp

     *------------------------------------------------------
     *-- calculate and store the number of main menu prompts
     *------------------------------------------------------
     _num_pmts= len(_menu_pmts_)

     *---------------------------------------------------------
     *-- declare and fill an array of JUST the main menu prompts
     *-- while calculating the total length of all main menu prompts
     *-- with allowances for leading trailing and in-between spaces
     *-------------------------------------------------------------
     private _main_pmt_[_num_pmts]      && stores main prompt strings
     private _len_pmts_[_num_pmts]      && stores main prompt string lengths
     private _pmt_col_[_num_pmts]       && stores column prompt starts at

     _len_main= 1
     _temp_col= _menu_col
     for x= 1 to _num_pmts
          _tilde= at("~",_menu_pmts_[x])
          _main_pmt_[x]= substr(_menu_pmts_[x], 1, if(_tilde> 0,;
               (_tilde - 1), (len(_menu_pmts_[x]) ) ) )
          _len_pmts_[x]= len(_main_pmt_[x])
          _pmt_col_[x]= _temp_col
          _temp_col= _temp_col + _len_pmts_[x] + 2
          _len_main= _len_main + _len_pmts_[x] + 2
     next x

     *------------------------------------------------------------
     *-- draw box based upon passed parameters and _len_main
     *------------------------------------------------------------
     box((_menu_row- 1), (_menu_col- 1), (_menu_row+ 1), ;
         ( (_menu_col- 1) + _len_main ),_frame,_box_clr,1,8)

     *------------------------------------------------------------
     *-- fill the box with main menu prompts
     *------------------------------------------------------------
     _curr_col= _menu_col + 1      && start printing at _menu_col parameter
     for x= 1 to _num_pmts
          print(_menu_row,_curr_col,_main_pmt_[x],_pmt_clr)
          print(_menu_row,_curr_col,substr(_main_pmt_[x],1,1),_first_clr)
          _curr_col= _curr_col + _len_pmts_[x] + 2
     next x

     *-----------------------------------------------------------
     *-- highlight first prompt
     *-----------------------------------------------------------
     Hili(_active)

     _menuing= .t.
     do while _menuing
          _the_key= inkey(0)
          do case
               case _the_key= 13
                    _scr_temp= savescreen()
                    _smchoice= Submenu(_active)
                    restscreen(_scr_temp)
                    if _smchoice> 0
                         retu(_active+ (_smchoice/10))
                    endif
               case isalpha(chr(_the_key))
                    *--check for both caps and lowercase
                    alph_key= _lower(chr(_the_key))
                    _t_active= ascan(_menu_pmts_,alph_key)
                    if _t_active= 0
                         alph_key= _upper(chr(_the_key))
                         _t_active= ascan(_menu_pmts_,alph_key)
                    endif
                    if _t_active > 0
                         Loli(_active)
                         _active= _t_active
                         Hili(_active)
                         _scr_temp= savescreen()
                         _smchoice= Submenu(_active)
                         restscreen(_scr_temp)
                         if _smchoice> 0
                              retu(_active+ (_smchoice/10))
                         endif
                    endif

               otherwise
                    Loli(_active)
                    do case
                         case _the_key= 4        && right arrow
                              _active= if(_active < _num_pmts, _active + 1, 1)
                         case _the_key= 19 .or. _the_key= 271
                              _active= if(_active = 1, _num_pmts , _active - 1)
                         case _the_key= 1
                              _active= 1
                         case _the_key= 6
                              _active= _num_pmts
                    endcase
                    Hili(_active)
          endcase
     enddo _menuing
return(_active)
*------------------------------------------------------------------------
function Hili
     parameters _the_pmt
     setattr(_menu_row, ( _pmt_col_[_the_pmt]), _menu_row, ;
          ( _pmt_col_[_the_pmt] + _len_pmts_[_the_pmt] + 1 ), _sel_clr)
return(.t.)
*------------------------------------------------------------------------
function Loli
     parameters _the_pmt
     setattr(_menu_row, ( _pmt_col_[_the_pmt]), _menu_row, ;
          ( _pmt_col_[_the_pmt] + _len_pmts_[_the_pmt] + 1 ), _pmt_clr)
     setattr(_menu_row, ( _pmt_col_[_the_pmt]+1), _menu_row, ;
          ( _pmt_col_[_the_pmt] + 1 ), _first_clr)
return(.t.)
*------------------------------------------------------------------------
function Submenu
     parameters _mactive
     private _temp_str,_num_subs,_longest,_scur_row,_sactive

     _sactive= 1

     *-- calculate number of prompts in this submenu
     _temp_str= substr(_menu_pmts_[_mactive], at("~", ;
     _menu_pmts_[_mactive])+1)
     _num_subs= chrcount("|",_temp_str)+1

     *-- declare array to hold submenu prompts and fill it up
     private _subpmts_[_num_subs]
     for x = 1 to _num_subs
          _subpmts_[x] = strextract(_temp_str,"|",x)
     next x

     *-- find longest element and pad the others with trailing spaces
     *-- so that all are the same length
     _longest= amaxstrlen(_subpmts_)+1
     for x= 1 to _num_subs
          _subpmts_[x]= untrim(_subpmts_[x],_longest)
     next x

     *-- display the pulldown box
     box( (_menu_row + 1), _pmt_col_[_active], (_menu_row + 1 + _num_subs;
     + 1), (_pmt_col_[_active]+ _longest + 2), _frame, _box_clr,1,8)

     *-- display the submenu prompts
     *-- and store row numbers to array for each prompt
     private _subrows_[_num_subs]
     _scur_row= _menu_row + 2
     for x= 1 to _num_subs
          print(_scur_row,_pmt_col_[_active]+2,_subpmts_[x],_pmt_clr)
          print(_scur_row,_pmt_col_[_active]+2,substr(_subpmts_[x],;
          1,1),_first_clr)
          _subrows_[x]= _scur_row
          _scur_row= _scur_row+1
     next x
     *-----------------------------------------------------------
     *-- highlight first prompt
     *-----------------------------------------------------------
     Hili_s(_sactive)
     _smenuing= .t.
     do while _smenuing
          _the_skey= inkey(0)
          Loli_s(_sactive)
          do case
               case _the_skey= 27
                    _smenuing= !_smenuing
               case _the_skey= 13
                     retu(_sactive)

               case isalpha(chr(_the_skey))
                    *--check for both caps and lowercase
                    salph_key= _lower(chr(_the_skey))
                    _st_active= ascan(_subpmts_,salph_key)
                    if _st_active= 0
                         salph_key= _upper(chr(_the_skey))
                         _st_active= ascan(_subpmts_,salph_key)
                    endif
                    if _st_active > 0
                         retu(_st_active)
                    endif

               case _the_skey= 24
                    _sactive= if(_sactive < _num_subs, _sactive +1,1)
               case _the_skey= 5
                    _sactive= if(_sactive = 1, _num_subs , _sactive - 1)
               case _the_skey= 4
                    _smenuing= !_smenuing
                    nstuff(27)
                    nstuff(4)
                    nstuff(13)
               case _the_skey= 19
                    _smenuing= !_smenuing
                    nstuff(27)
                    nstuff(271)
                    nstuff(13)
               case _the_skey= 1
                    _sactive= 1
               case _the_skey= 6
                    _sactive= _num_subs
          endcase
          Hili_s(_sactive)
     enddo
return(0)
*-------------------------------------------------------------------
function Hili_s
     parameters _the_pmt
     setattr(_subrows_[_the_pmt], _pmt_col_[_active]+1, _subrows_[_the_pmt], ;
          (_pmt_col_[_active]+ _longest + 1),_sel_clr)
return(.t.)
*------------------------------------------------------------------------
function Loli_s
     parameters _the_pmt
     setattr(_subrows_[_the_pmt], _pmt_col_[_active]+1, _subrows_[_the_pmt], ;
          (_pmt_col_[_active]+ _longest + 1),_pmt_clr)
     setattr(_subrows_[_the_pmt],(_pmt_col_[_active]+2),_subrows_[_the_pmt],;
          (_pmt_col_[_active]+2), _first_clr)
return(.t.)
*-------------------------------------------------------------------------





